﻿using System;

namespace _01_V_IntroIndexer
{
    class Person
    {
        #region Datenfelder
        public string Name { get; private set; }
        private string vorname;
        private int alter;
        #endregion

        #region Konstruktoren
        public Person(string Name)  // Aufruf z.B. bei "Claudia"
        {
            this.Name = Name;
            vorname = null;
            alter = -1;
        }
        public Person(string name, string Vorname, int Alter = 0)
        {
            if (Alter < 0)
                throw new ArgumentOutOfRangeException("Alter muss eine positive Zahl sein!");
            this.Name = name;       // this.name ~ Datenfeld name; "nur" name ~ Parameter!!!
            vorname = Vorname;
            alter = Alter;
        }
        #endregion

        #region (Datenfeld-) Zugriffsfunktionen
        public void ErhöheAlter()
        {
            alter++;
        }
        public int getAlter()
        {
            return alter;
        }
        public int getAlter2() => alter;
        public void setAlter(int value)
        {
            if (value < 0 || value > 150)
                throw new ArgumentException("Alter muss im Bereich 0..150 sein!");
            alter = value;
        }

        // Property-Schreibweise
        public int Alter
        {
            get => alter;
            set
            {
                if (value < 0 || value > 150)
                    throw new ArgumentException("Alter muss im Bereich 0..150 sein!");
                alter = value;
            }
        }
        #endregion

        #region Sonstige Methoden
        public void Ausgabe()               // Ausgabe hat den impliziten Parameter this
        {
            //Console.WriteLine($"Person: {this.vorname} {this.name}, Alter: {this.alter}");
            Console.WriteLine($"Person: {vorname} {Name}, Alter: {alter}");
        }
        public static void Ausgabe(Person p)    // Ausgabe hat ausschließlich den Parameter p
        {
            Console.WriteLine($"Person: {p.vorname} {p.Name}, Alter: {p.alter}");
        }
        public override string ToString()
        {
            return $">>> Person: {vorname} {Name}, Alter: {alter}";
        }
        #endregion
    }
}
