﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _01_V_IntroIndexer
{
    class Personenliste
    {
        Person[] personen;
        int capacity;
        int count;

        public Personenliste(int Capacity)
        {
            capacity = Capacity;
            count = 0;
            personen = new Person[capacity];
        }
        public void Add(Person p)
        {
            if (count < capacity)
                personen[count++] = p;
            else
                throw new IndexOutOfRangeException("Feld ist zu klein");
        }
        public Person this[int index]
        // this = Name für einen Indexer
        // index-Parameter in eckigen Klammern
        {
            get { return personen[index]; }
            set
            {
                if (index < 0 || index >= capacity)
                    throw new IndexOutOfRangeException("Der Index lag außerhalb des Personenfeldes");
                personen[index] = value;
            }
        }
        public Person this[string name]
        // this = Name für einen Indexer
        // index-Parameter kann von beliebigem Typ sein und es
        //    können beliebig viele Parameter angegeben werden
        {
            get
            {
                for (int i = 0; i < capacity; i++)
                {
                    if (personen[i] != null && personen[i].Name == name)
                        return personen[i];
                }
                return null;
            }
        }

        public IEnumerator<Person> GetEnumerator()
            // GetEnumerator --> Returntyp IEnumerator
            //    Spezifischer Returntyp IEnumerator<hier Person>
        {
            for (int i = 0; i < capacity; i++)
            {
                if (personen[i] != null)
                    yield return personen[i];
            }
        }
    }
}
