﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _02_4_VerketteteStrukturenIntro
{
    
    class Liste
    {
        // LItem ist eine private Klasse der Klasse Liste
        // private ~ Liste darf auf LItem zugreifen
        // Methoden außerhalb von Liste dürfen dies nicht!
        private class LItem
        {
            public int zahl;
            public LItem next;

            public LItem(int k) { zahl = k; next = null; }
        }
                
        private LItem first, last;
        private int anz;

        public Liste()
        {
            first = last = null;
        }
        public void AddLast(int k)
        {
            LItem neu = new LItem(k);
            anz++;

            if (first == null)
                first = last = neu;
            else
            {
                last.next = neu;    // Schritt (1)
                last = neu;         // Schritt (2)
            }
        }
        public void AddFirst(int k)
        {
            LItem neu = new LItem(k);
            anz++;

            if (first == null)
                first = last = neu;
            else
            {
                neu.next = first;   // Schritt (1)
                first = neu;        // Schritt (2)
            }
        }
        public void Ausgabe()
        {
            for (LItem item = first; item != null; item = item.next)
                Console.WriteLine(item.zahl);

            //LItem item = first;
            //while (item!=null)
            //{
            //    Console.WriteLine(item.zahl);
            //    item = item.next;
            //}
        }
        public int this[int ind]
        {
            get
            {
                LItem item = first;
                for (int i = 0; i < ind; i++)
                    item = item.next;
                return item.zahl;
            }
        }
        public IEnumerator<int> GetEnumerator()
        {
            for (LItem item = first; item != null; item = item.next)
                yield return item.zahl;
        }


        public void AddBeforeNth(int index, int zahl)
        {
            if (index < 0 || index > anz)
                throw new ArgumentOutOfRangeException("Index außerhalb der Listengröße");
            if (index == 0)
                AddFirst(zahl);
            else if (index == anz)
                AddLast(zahl);
            else // Wir wissen: Nicht vor das erste und nicht hinter das letzte Element
                 // Es gibt mindestens ein Element VORHER und ein Element NACHHER
            {
                LItem neu = new LItem(zahl);
                anz++;
                LItem item = first;
                for (int i = 1; i < index; i++) // Element mit index-1 suchen
                    item = item.next;

                // REIHENFOLGE ist ENTSCHEIDEND
                neu.next = item.next;   // #1 Nachfolgeradresse im neuen Elem. speichern
                item.next = neu;        // #2 Nachfolger von Elem[index-1] auf das neue Element setzen
            }
        }

        public void DeleteFirst()
        {
            // 1.Fall: Liste ist leer
            // 2.Fall: Liste besteht nur aus einem Element
            // 3.Fall: Liste hat mehr als ein Element
            if (anz == 0)
                return;

            anz--;
            if (anz == 0)
                first = last = null;
            else // Wir wissen: Die Liste enthält MEHR als ein Element!
                first = first.next;
        }
    }
}
