﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _04_UbgListe_Mo
{
    class ToDoListe
    {
        /* private */ class ToDoItem
        {
            public string todo;
            public ToDoItem next;
            public ToDoItem(string s) { todo = s; next = null; }
        }

        ToDoItem first = null, last = null;
        int count = 0;

        public void Add(string ToDo)
        {
            // Fall 1: Liste ist leer
            // Fall 2: Liste besitzt schon Elemente

            ToDoItem newItem = new ToDoItem(ToDo);
            count++;

            if (first == null)
                first = last = newItem;  // Fall 1
            else
            {                            // Fall 2
                last.next = newItem;
                last = newItem;
            }
        }
        //public string[] GetAll()
        //{
        //    string[] res = new string[count];
        //    int x = 0;

        //    for (ToDoItem item = first; item != null; item = item.next)
        //        res[x++] = item.todo;
        //    return res;
        //}
        public IEnumerator<string> GetEnumerator()
        {
            for (ToDoItem item = first; item != null; item = item.next)
                yield return item.todo;
        }
        public string[] GetAll()
        {
            string[] res = new string[count];
            int x = 0;

            foreach (string item in this)
                res[x++] = item;
            return res;
        }

        private ToDoItem ElementN(int ind)
        {
            ToDoItem item = first;
            for (int i = 0; i < ind; i++)
                item = item.next;
            return item;
        }
        public string this[int ind]
        {
            get => ElementN(ind).todo;
            //{
            //    ToDoItem item = ElementN(ind);
            //    return item.todo;
            //}
            set
            {
                //ToDoItem item = ElementN(ind);
                //item.todo = value;
                ElementN(ind).todo = value;
            }
        }
        private ToDoItem FindText(string text)
        {
            for (ToDoItem item = first; item != null; item = item.next)
                if (item.todo.Contains(text))
                    return item;
            return null;
        }
        public string this[string text]
        {
            get => FindText(text).todo;
            
            set
            {
                FindText(text).todo = value;
            }
        }
    }
}
