﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _05_1_BinTree
{
    class BinTree
    {
        class BItem
        {
            public int number;
            public BItem left = null, right = null;
            public BItem (int Number) { number = Number; }
            public override string ToString()
            {
                string lString = (left == null) ? "null" : left.number.ToString();
                string rString = (right == null) ? "null" : right.number.ToString();
                return $"left:{lString} <- {number} -> right:{rString}";
            }
        }
        BItem root = null;

        public void BInsert(int Number)
        {
            BItem newItem = new BItem(Number);
            if (root == null)
                root = newItem;
            else
            {
                bool done = false;
                BItem item = root;
                do
                {
                    if (Number < item.number) // linker Teilbaum
                    {
                        if (item.left == null)
                        {
                            item.left = newItem;
                            done = true;
                        }
                        else
                            item = item.left;
                    }
                    else
                    {
                        if (item.right == null)
                        {
                            item.right = newItem;
                            done = true;
                        }
                        else
                            item = item.right;
                    }
                } while (!done);
            }
        }
        public bool FindItem(int Number)
        {
            BItem item = root;
            while (item != null)
            {
                if (Number == item.number)
                    return true;
                item = (Number < item.number) ? item.left : item.right;
            }
            return false;
        }
        public void InOrderPrint()
        {
            InOrderPrint(root);
        }
        private void InOrderPrint(BItem item)
        {   // kleiner -- selbst -- größer
            if (item != null)
            {
                Console.Write("( ");
                if (item.left != null)
                    InOrderPrint(item.left);
                    // linke Elemente ausgeben
                Console.Write("  "+item.number+ "  ");
                if (item.right != null)
                    InOrderPrint(item.right);
                // rechte Elemente ausgeben
                Console.Write(" )");
            }
        }

        private IEnumerable<int> GetEnum(BItem item)
        {
            if (item != null)
            {
                foreach (var item2 in GetEnum(item.left))
                    yield return item2;

                yield return item.number;

                foreach (var item2 in GetEnum(item.right))
                    yield return item2;
            }
        }
        public IEnumerator<int> GetEnumerator()
        {
            foreach (var item in GetEnum(root))
                yield return item;
        }

        public void PreOrderPrint()
        {
            PreOrderPrint(root);
        }
        private void PreOrderPrint(BItem item)
        {   // kleiner -- selbst -- größer
            if (item != null)
            {
                Console.Write("( ");
                Console.Write("  " + item.number + "  ");

                if (item.left != null)
                    PreOrderPrint(item.left);
                // linke Elemente ausgeben

                if (item.right != null)
                    PreOrderPrint(item.right);
                // rechte Elemente ausgeben
                Console.Write(" )");
            }
        }
    }
}
