﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _05_UbgBinTree_Di
{
    // Programmieren Sie einen binären Baum, mit den Datenfeldern
    // string Name
    // int leftCount, rightCount  -- Anzahl der Elemente im linken bzw. rechten Ast
    // und den folgenden Methoden
    // void Insert(string Name) -- Einfügen des Namens
    // int Level(string Name) -> Liefert die Ebene zurück auf der sich der
    //                           Knoten befindet (root=0, Nicht gefunden=-1)

    // Diskutieren Sie Ansätze, wie ein Knoten gelöscht werden könnte
    // Diskutieren Sie, wie ein Baum ausgegeben werden könnte

    class BinTree
    {
        class BItem
        {
            public string name;
            public BItem left = null, right = null;
            public int lCount=0, rCount = 0;
            public BItem(string Name) { name = Name; }
            public override string ToString()
            {
                string lString = (left == null) ? "null" : left.name;
                string rString = (right == null) ? "null" : right.name;
                return $"left:{lString} -- {name}|{lCount}|{rCount} -- right:{rString}";
            }
        }
        BItem root = null;

        public void BInsert(string InsName)
        {
            BItem newItem = new BItem(InsName);
            if (root == null)
                root = newItem;
            else
            {
                bool done = false;
                BItem item = root;
                do
                {
                    if (InsName.CompareTo(item.name) < 0) // links oder rechts
                    {
                        item.lCount++;
                        if (item.left == null)
                        {
                            item.left = newItem;
                            done = true;
                        }
                        else
                            item = item.left;
                    }
                    else
                    {
                        item.rCount++;
                        if (item.right == null)
                        {
                            item.right = newItem;
                            done = true;
                        }
                        else
                            item = item.right;
                    }
                } while (!done);
            }
        }
        public int Level(string Name)
        {
            int level = 0;
            BItem item = root;
            while (item != null)
            {
                if (Name == item.name)
                    return level;
                level++;
                item = (Name.CompareTo(item.name) < 0) ? item.left : item.right;
            }
            return -1;
        }
    }
}
