﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _05_UbgCycleList_Mo
{ 
    // Schreiben Sie eine doppelt-verkettete Liste, die die Möglichkeit bietet,
    // das letzte Element wieder mit dem ersten zu verbinden (Zyklus schließen)
    // Eingebettete Klasse Element
    // Nutzlast: string name
    // Methoden:
    class CycleList
    {
        class LItem
        {
            public string name;
            public LItem prev=null, next = null;
            public LItem(string Name) { name = Name; }
        }
        LItem first = null, last = null;
        LItem iterator = null;

        public void AddEnd(string Name) // wie bisher
        {
            LItem newItem = new LItem(Name);

            if (first == null)
                first = last = newItem;
            else  // Es gibt schon Listenelemente
            {
                newItem.prev = last;
                last.next = newItem;
                last = newItem;
                first.prev = null;
            }
        }
        public void CloseCycle() // letztes mit dem ersten Element verbinden
        { 
            if (first != null)
            {
                last.next = first;
                first.prev = last;
            }

        }
        public void Print()
        {
            if (first == null)
                return;
            
            LItem item = first;
            do
            {
                Console.WriteLine(item.name);
                item = item.next;
                // Ende, gdw. item == null oder item == first
            } while (!(item == null || item == first));
        }
        public IEnumerator<string> GetEnumerator()
        {
            if (first != null)
            {
                LItem item = first;
                do
                {
                    yield return item.name;
                    item = item.next;
                    // Ende, gdw. item == null oder item == first
                } while (!(item == null || item == first));
            }
        }
        public void SetIterator(int offset = 0) // Einen internen Zeiger (Iterator) auf das (anfang+offset) Listenelement setzen
        {
            if (first == null)
                iterator = null;
            else
            {
                iterator = first;
                for (int i = 0; i < offset; i++)
                    iterator = iterator.next;
            }
        }
        public string GetName() // Den string zurückliefern, der im Iterator-Listenelement gespeichert ist
        {
            return iterator.name;
        }
        public void MoveToNext() { iterator = iterator.next; }
        public void MoveToPrev() { iterator = iterator.prev; }

        
    }
}
