﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _06_UbgBinTree_Mo
{
    // Programmieren Sie einen binären Baum, mit den Datenfeldern
    // string Name
    // int leftCount, rightCount  -- Anzahl der Elemente im linken bzw. rechten Ast
    // und den folgenden Methoden
    // void Insert(string Name) -- Einfügen des Namens
    // int Level(string Name) -> Liefert die Ebene zurück auf der sich der
    //                           Knoten befindet (root=0, Nicht gefunden=-1)
    // void Print() -- InOrder-Ausgeben des Baums

    // Diskutieren Sie Ansätze, wie ein Knoten gelöscht werden könnte
    
    class BinTree
    {
        class BItem
        {   
            public string name;
            public BItem left = null, right = null;
            public int lCount = 0, rCount = 0;
            public BItem(string Name) { name = Name; }
            public override string ToString()
            {
                string lString = (left == null) ? "null" : left.name;
                string rString = (right == null) ? "null" : right.name;
                return $"left:{lString} <- {name}|{lCount}|{rCount} -> right:{rString}";
            }
        }
        BItem root = null;

        public void BInsert(string Name)
        {
            BItem newItem = new BItem(Name);
            if (root == null)
                root = newItem;
            else
            {
                bool done = false;
                BItem item = root;
                do
                {
                    if (Name.CompareTo(item.name)<0) 
                            // Name < item.name  --> Name - item.name < 0
                            // Name.CompareTo(item.name) < 0
                            // --> linker Teilbaum
                    {
                        item.lCount++;
                        if (item.left == null)
                        {
                            item.left = newItem;
                            done = true;
                        }
                        else
                            item = item.left;
                    }
                    else
                    {
                        item.rCount++;
                        if (item.right == null)
                        {
                            item.right = newItem;
                            done = true;
                        }
                        else
                            item = item.right;
                    }
                } while (!done);
            }
        }
        public int Level(string Name)
        {
            BItem item = root;
            int level = 0;
            while (item != null)
            {
                if (Name == item.name)
                    return level;
                level++;
                item = (Name.CompareTo(item.name)<0) ? item.left : item.right;
            }
            return -1;
        }
        public void Print() { Print(root); }
        private void Print(BItem item)
        {
            if (item != null)
            {
                if (item.left != null)
                    Print(item.left);

                Console.WriteLine(item.name);

                if (item.right != null) 
                    Print(item.right);
            }
        }
        public int Fib(int n)
        {
            if (n < 2)
                return 1;
            else
                return Fib(n - 1) + Fib(n - 2);
        }
    }
}
