﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _07_1_Intro_Interfaces
{
    interface IBesteuerbar
    {
        /* public abstract */ double Steuern();
    }
    // Interface ist eine abstrakte Klasse
    // alle Methoden sind public und abstract

    interface IVerkaufbar
    {
        void Verkaufen();
        //double Wert { get; set; }
    }





    abstract class Kfz : IBesteuerbar, IVerkaufbar
    {
        // Je nach Anwendung: Property entweder in Kfz realisieren ...
        //double wert;
        //public double Wert { get => wert; set { wert = value; } }

        // ... oder die Realisierung "weiterschieben"
        //public abstract double Wert { get; set; }

        public abstract double Steuern();

        // public void Verkaufen() {}
        //      -- Erfüllung des Interfaces
        // public virtual void Verkaufen() {}
        //      -- Erfüllung des Interfaces PLUS kann in abgeleiteten Klassen spezialisiert werden
        // public abstract void Verkaufen();
        //      -- Erkenne die Verpflichtung des Interfaces an Erfüllung in den abgeleiteten Klassen
        public virtual void Verkaufen()
        {
            Console.WriteLine("Verkauft");
        }
        public abstract void Fahren();

    }

    class Pkw : Kfz
    {
        public int AnzahlSitze { get; private set; }
        public override void Fahren()
        {
            Console.WriteLine("Pkw fährt");
        }

        public override double Steuern()
        {
            return 100;
        }

        //public override void Verkaufen()
        //{
        //    Console.WriteLine("Pkw wird verkauft");
        //}
    }

    class Sportwagen : Pkw
    {
        public override void Verkaufen()
        {
            Console.WriteLine("Sportwagen wird verkauft");
        }
    }


    //class Motorrad : Kfz
    //{

    //}
    class Pflanzen : IVerkaufbar
    {
        public void Verkaufen()
        {
            Console.WriteLine("Pflanze wird verkauft");
        }
    }

    class Immobilien : IBesteuerbar, IVerkaufbar
    {
        // Steuern() und Verkaufen() müssen direkt implementiert werden, da ansonsten
        // nicht alle abstrakten Methoden implementiert sind
        public  double Steuern() => 999;
        public void Verkaufen() 
        { 
            Console.WriteLine("Immobilie wird verkauft"); 
        }
    }
}
