﻿using System;

namespace _07_2_Intro_Exceptions
{
    class MeinFehler : Exception
    {
        public int FehlerCode { get; private set; }
        public MeinFehler(string message, int fehlercode) : base(message)
        {
            FehlerCode = fehlercode;
        }
    }

    class Program
    {
        static void funktion1(int x)
        {
            if (x < 0)
                throw new ArgumentOutOfRangeException("Argument darf nicht negativ sein");
            Console.WriteLine("Funktion1: Ich war hier");
        }
        static void funktion2(int x)
        {
            if (x == 0)
                throw new ArithmeticException("Argument darf nicht 0 sein");
            Console.WriteLine("Funktion2: Ich war hier");
        }
        static void funktion3(int x)
        {
            if (x == 0)
                throw new MeinFehler("Fehler in Funktion 3", x);
            Console.WriteLine("Funktion3: Ich war hier");
        }
        static void Main(string[] args)
        {
            try
            {
                try
                {
                    Console.WriteLine("Vor Funktion1");
                    funktion1(1);
                    funktion2(2);
                    funktion3(0);
                    Console.WriteLine("Nach Funktion1");
                }
                catch (ArgumentOutOfRangeException e)  // catch fängt FehlerTYPEN
                {
                    Console.WriteLine("Es ist eine ArgumentOutOfRangeException aufgetreten");
                    Console.WriteLine($"Fehler: {e.Message}");
                }
                catch (ArithmeticException)  // catch fängt FehlerTYPEN
                {
                    Console.WriteLine("Es ist ein Arithmetikfehler aufgetreten");
                }
                catch (MeinFehler mf)  // catch fängt FehlerTYPEN
                {
                    Console.WriteLine($"{mf.Message} | {mf.FehlerCode}");
                    throw new ArgumentException();
                    throw;  // Weiterwerfen des Fehlerobjekts
                }
                catch (Exception)   // Zuerst die spezifischen Fehler fangen, dann die allgemeineren!!!
                {
                    Console.WriteLine("Es ist ein allgemeiner Fehler aufgetreten");
                }
                finally
                {
                    Console.WriteLine("Wird immer ausgeführt");
                    // Zum Beispiel Dateien schließen, Ressourcen freigeben
                    // Bei ...
                    // Fehlerfreier Ausführung des try-Blocks
                    // Fehlerhafter Ausführung des try-Blocks mit und ohne catch 
                    //     (auch mit weiterem throw [mit und ohne Parameter] )
                }
            }
            catch (ArgumentException)
            {
                Console.WriteLine("Hab Dich!");
            }
        }
    }
}
