﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _07_Ubg_Warenwirtschaft_Di
{
    // Programmieren Sie ein rudimentäres System zur Verwaltung beliebiger Produkte
    // Jedes Produkt soll die folgenden Eigenschaften besitzen, 
    //      int stueckzahl, double preis, string name
    // Es soll eigene (abstract oder nicht-abstract) Klassen für einzelne Produkte mit individuellen Datenfeldern geben: 
    // - Metallwaren mit den Unterklassen Schrauben und Nägel
    // - Milchprodukte mit den Unterklassen Joghurt und Butter 
    // - Gartenprodukte mit den Unterklassen Pflanzen und Container; Schreiben Sie für die Pflanze eine besondere
    //         Methode, die nur Pflanzen haben (z.B. Giessen)
    // Erstellen Sie diese Klassen/Unterklassen mit geeigneten Konstruktoren, Basisklassenaufrufen, usw.
    // Entscheiden Sie, wie Sie vererben wollen (virtual/abstract)
    // Geben Sie für jede Klasse - wo sinnvoll - eine Überschreibung der ToString()-Methode an
    // Legen Sie in Main() ein Feld mit einem Objekt je Klasse an, geben Sie alle Elemente in einer Schleife aus
    // und schreiben Sie eine Methode, die z.B. nach der Pflanze über den Namen sucht und dieses Objekt zurückliefert
    // Rufen Sie dann für die Pflanze diese besondere Methode auf.

    interface IBegiessbar
    {
        void Giessen();
    }
    abstract class Produkt
    {
        int stueckzahl;
        double preis;
        // protected string name;
        public string Name { get; protected set; }
        // private: Nur die Methoden dieser Klasse Produkt dürfen das set-Name aufrufen
        // protected: Die Methoden dieser Klasse Produkt und die Methoden der von Produkt
        // abgeleiteten Klassen dürfen set-Name aufrufen; gilt auch transitiv
        public Produkt(int stueckzahl, double preis, string name)
        {
            this.stueckzahl = stueckzahl;
            this.preis = preis;
            this.Name = name;
        }
        public double Wert() => preis * stueckzahl;
    }
    abstract class Gartenprodukte : Produkt
    {
        public Gartenprodukte(int stückzahl, double preis, string name)
            : base(stückzahl, preis, name)
            { }
    }
    class Pflanze : Gartenprodukte, IBegiessbar
    {
        public enum Pflanzentyp { zier, nutz };
        Pflanzentyp typ;
        public Pflanze(int stückzahl, double preis, string name, Pflanzentyp typ)
            : base(stückzahl, preis, name)
        {
            this.typ = typ;
        }
        public void Giessen() { Console.WriteLine($"Pflanze {Name} wird gegossen"); }
    }
    class Froesche : Produkt, IBegiessbar
    {
        public Froesche(int stückzahl, double preis, string name)
            : base(stückzahl, preis, name) { }
        public void Giessen()
        {
            Console.WriteLine("Frosch wird begossen");
        }
    }
}
