﻿using System;

namespace _07_Ubg_Warenwirtschaft_Di
{
    class Program
    {
        static void Main(string[] args)
        {
            Produkt[] produkte = new Produkt[3];
            produkte[0] = new Pflanze(10, 0.35, "Geranien", Pflanze.Pflanzentyp.zier);
            produkte[1] = new Froesche(5, 2.49, "Hopper");
            produkte[2] = new Pflanze(10, 0.55, "Salat", Pflanze.Pflanzentyp.nutz);
            foreach (var item in produkte)
            {
                Console.WriteLine(item.Wert());
                if (item is IBegiessbar)
                {
                    // item.Giessen(); -- Geht nicht, da der statische Typ die aufrufbaren Methoden def.
                    if (item is Pflanze)
                        ((Pflanze)item).Giessen();
                    // Falls die Konvertierung in eine Pflanze nicht möglich ist --> Exception

                    (item as Pflanze).Giessen();
                    // Falls die Konvertierung in eine Pflanze nicht möglich ist --> as liefert null
                    //   --> NullReferenceException

                    (item as Pflanze)?.Giessen();
                    // Nur wenn die Konvertierung funktioniert, wird Giessen() aufgerufen,
                    // ansonsten "null" zurückgegeben;

                    if (item is Pflanze pflanze)
                        pflanze.Giessen();
                    // Wenn item vom Typ "Pflanzen" ist, wird die konvertierte Objektreferenz in pflanze gespeichert

                    Console.WriteLine("----------");
                    (item as IBegiessbar)?.Giessen();
                }
            }
        }
    }
}
