﻿using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Text;

namespace _09_1_KeyValueList
{
    class KeyValueList<K, V> : IComparable<KeyValueList<K, V>>  where K : IComparable<K>
    {
        private class KVItem
        {
            public K key;
            public V val;
            public KVItem next = null;
            public KVItem(K key, V val) { this.key = key; this.val = val; }
            public override string ToString() => $"{key}: {val}";
        }
        KVItem first = null, last = null;
        int count = 0;

        public int CompareTo(KeyValueList<K, V> other) => 0; // Noch Dummy-Implementierung
        private void AddEnd(K key, V val)
        {
            KVItem newItem = new KVItem(key, val);   // 1. Neues Element anlegen
            count++;
            if (first == null)                            // 2. Leere Liste?
                first = last = newItem;
            else
            {
                last.next = newItem;               // 3. Neues Element am Ende anfügen
                last = last.next;
            }
        }
        public IEnumerator<KeyValuePaar<K, V>> GetEnumerator()
        {
            for (KVItem item = first; item != null; item = item.next)
                yield return new KeyValuePaar<K, V>(item.key, item.val);
        }
        private KVItem ItemSearch(K searchKey)
        {
            for (KVItem item = first; item != null; item = item.next)
                if (item.key.CompareTo(searchKey) == 0)
                    return item;
            return null;
        }
        public V this[K key]
        {
            get
            {
                KVItem item = ItemSearch(key);
                if (item != null)
                    return item.val;
                throw new Exception($"Der Schlüssel {key} wurde nicht gefunden");
            }
            set
            {
                KVItem item = ItemSearch(key);
                if (item != null)       // Existiert der Schlüssel schon in der Liste?
                    item.val = value;
                else
                    AddEnd(key, value);
            }
        }
        public KeyValueList<K, V> Copy()
        {
            KeyValueList<K, V> res = new KeyValueList<K, V>();
            // ...
            return res;
        }


    }
}
