﻿using System;
using System.Collections.Generic;

namespace _09_1_KeyValueList
{
    class Program
    {
        static void Main(string[] args)
        {
            KeyValueList<string, int> telListe = new KeyValueList<string, int>();
            //telListe.AddEnd("Wienkop", 1614);
            //telListe.AddEnd("Otsa", 1855);

            telListe["Wienkop"] = 1614;
            telListe["Otsa"] = 1855;
            Console.WriteLine(telListe["Otsa"]);

            telListe["Otsa"] = 9999;
            Console.WriteLine(telListe["Otsa"]);

            foreach (var item in telListe)
            {
                Console.WriteLine($"Telefonnummer von {item.key}: {item.val}");
            }

            List<string> termineMo = new List<string>();
            termineMo.Add("08:00 Dig. Bildbearbeitung");
            termineMo.Add("09:45 Prog2 Übung");
            termineMo.Add("11:30 Prog2 Vorlesung");

            List<string> termineDi = new List<string>();
            termineDi.Add("08:00 Prog2 Übung");
            termineDi.Add("09:45 Prog2 Vorlesung");

            KeyValueList<string, List<string>> terminkalender = new KeyValueList<string, List<string>>();
            terminkalender["17.05.2021"] = termineMo;
            terminkalender["18.05.2021"] = termineDi;

            foreach (var tag in terminkalender)
            {
                Console.WriteLine($"\nTermine am {tag.key}:");
                foreach (var item in tag.val)
                {
                    Console.WriteLine(item);
                }
            }
            Console.WriteLine("*************");

            #region Terminkalender2
            KeyValueList<string, KeyValueList<string, string>> terminkalender2 = new KeyValueList<string, KeyValueList<string, string>>();
            terminkalender2["17.05.2021"] = new KeyValueList<string, string>();
            terminkalender2["17.05.2021"]["09:45"] = "Prog2 Übung";
            terminkalender2["17.05.2021"]["11:30"] = "Prog2 Vorlesung";

            terminkalender2["18.05.2021"] = new KeyValueList<string, string>();
            terminkalender2["18.05.2021"]["08:00"] = "Prog2 Übung";
            terminkalender2["18.05.2021"]["09:45"] = "Prog2 Vorlesung";

            foreach (var tag in terminkalender2)
            {
                Console.WriteLine($"\nTermine am {tag.key}:");
                foreach (var termin in tag.val)
                {
                    Console.WriteLine(termin);
                }
                Console.WriteLine("---------");
            }
            #endregion

            #region Rezeptverwaltung
            // Pfannkuchen, Zutaten(Mehl, Milch, Eier), Zubereitung (Schritt1, Schritt2, ...)
            KeyValueList<string, (List<string>, List<string>)> rezepte = new KeyValueList<string, (List<string>, List<string>)>();
            
            List<string> zutaten = new List<string>();
            zutaten.Add("Mehl");
            zutaten.Add("Milch");
            zutaten.Add("Eier");
            List<string> zubereitung = new List<string>();
            zubereitung.Add("Eier in Schüssel schlagen");
            zubereitung.Add("mit Mehl und Milch verrühren");

            rezepte["Pfannkuchen"] = (zutaten, zubereitung);


            List<string> zutaten2;
            List<string> zubereitung2;
            (zutaten2, zubereitung2) = rezepte["Pfannkuchen"];


            Console.WriteLine("\nZutaten: ");
            foreach (var item in zutaten2)
            {
                Console.WriteLine(item);
            }

            Console.WriteLine("\nZubereitung:");
            foreach (var item in zubereitung2)
            {
                Console.WriteLine(item);
            }
            #endregion

            KeyValueList<KeyValueList<string, string>, string> terminkalender3;
        }
    }
}
