﻿using System;

namespace _09_3_Intro_Delegates
{
    class Program
    {
        delegate double MyFunction(double zzz);
            // Stellvertreterdefinition für Funktionen mit genau einem double Eingangsparameter und
            //      mit einem double-Returnwert

        static void Wertetabelle(double von, double bis, MyFunction funktion)
        {
            for (double x = von; x <= bis; x += 1)
                Console.WriteLine($"{x,6:f2} | {funktion(x)}");
            Console.WriteLine("------------------");
        }

        // ^^^^^^^^ FIRMA A ^^^^^^


        // -------- FIRMA B ------

        static double Quadrieren(double xxx) => xxx * xxx;

        static void Main(string[] args)
        {
            Wertetabelle(0, 3, Math.Sin);
            Wertetabelle(0, 3, Quadrieren);
            Wertetabelle(0, 3, delegate (double x) { return 2 * x; });     // Anonyme Methode
            Wertetabelle(0, 3, x  => 2 * x);                               // Lambda Ausdruck
        }
    }
}
