﻿using System;
using System.Collections.Generic;
using System.Text;

// Erstellen Sie mit Hilfe einer Liste einen generischen Stapel (Stack), in dem beliebige Elemente
// gespeichert werden können.
// Ein Stack ist eine Datenstruktur, ähnlich wie ein Stapel auf Ihrem Schreibtisch. Das, was 
// zuoberst aufliegt, wird auch zuerst wieder heruntergenommen.
// Sie können einen Stapel leicht mithilfe einer Liste aufbauen. Hierfür benötigen Sie folgenden Methoden:
// - AddFirst: Als erstes Element einfügen
// - GetFirst(bool removeFromStack=true): Liefert das erste Element zurück und entfernt es vom Stapel; kann 
//            per removeFromStack unterbunden werden
// - bool IsEmpty signalisiert, ob der Stack leer ist
// - Contains(T): Sucht nach dem übergebenen Element und liefert true/false zurück
// - GetEnumerator() : Ermöglicht einen Durchlauf durch den Stapel und liefert nach und nach alle Elemente zurück

namespace _09_Ubg_GenericStack_Di
{
    class GenericStack<T> where T:IEquatable<T>
    {   // where-Einschränkungen:
        //  class ~ Referenzvariable
        //  struct ~ Wertetyp
        //  new ~ T muss einen Defaultkonstruktor haben
        class StackItem
        {
            public T data;
            public StackItem next;
            public StackItem(T Data) { data = Data; next = null; }
        }
        StackItem first = null;

        public void Addfirst(T Data)
        {
            StackItem item = new StackItem(Data);
            item.next = first;
            first = item;
        }
        public T GetFirst(bool removeFromStack = true)
        {
            //if (first == null)
            //    return default(T);
            //T variable = default(T);

            if (first == null)
                throw new Exception("Stack ist leer!");

            T res = first.data;
            if (removeFromStack)
                first = first.next;
            return res;

            //first = first.next;       FALSCH!!!
            //return first.data;
        }
        public bool IsEmpty { get => first == null; }

        public IEnumerator<T> GetEnumerator()
        {
            for (StackItem item = first; item!=null; item=item.next)
            {
                yield return item.data;
            }
        }
        public bool Contains(T searchData)
        {
            for (StackItem item = first; item != null; item = item.next)
            { // Equals ~ Test auf Gleichheit
                if (item.data.Equals(searchData))
                    return true;
            }
            return false;
        }
    }
}
