﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _09_Ubg_GenericStack_Mo
{
    // Erstellen Sie mit Hilfe einer Liste einen generischen Stapel (Stack), in dem beliebige Elemente
    // gespeichert werden können.
    // Ein Stack ist eine Datenstruktur, ähnlich wie ein Stapel auf Ihrem Schreibtisch. Das, was 
    // zuoberst aufliegt, wird auch zuerst wieder heruntergenommen.
    // Sie können einen Stapel leicht mithilfe einer Liste aufbauen. Hierfür benötigen Sie folgenden Methoden:
    // - AddFirst: Als erstes Element einfügen
    // - GetFirst(bool removeFromStack=true): Liefert das erste Element zurück und entfernt es vom Stapel; kann 
    //            per removeFromStack unterbunden werden
    // - Contains(T): Sucht nach dem übergebenen Element und liefert true/false zurück
    // - GetEnumerator() : Ermöglicht einen Durchlauf durch den Stapel und liefert nach und nach alle Elemente zurück

    class GenericStack<T> where T:IComparable<T>
    {
        class StackItem
        {
            public T data;
            public StackItem next;
            public StackItem (T Data) { data = Data; next = null; }
        }
        StackItem first = null;

        public void AddFirst(T Data)
        {
            StackItem item = new StackItem(Data);
            if (first == null)
                first = item;
            else
            {
                item.next = first;
                first = item;
            }
        }
        public bool IsEmpty { get => (first == null); }
        public T GetFirst(bool removeFromStack = true)
        {
            if (first == null)
                throw new Exception("Leerer Stack");
                //return default(T);
                // return null;    // Nur bei Referenztypen zulässig ~ class
            T res = first.data;
            if (removeFromStack)
                first = first.next;
            return res;
        }

        public bool Contains (T value)
        {
            for (StackItem item = first; item != null; item=item.next)
            {
                if (item.data.CompareTo(value) == 0)
                    return true;
            }
            return false;
        }
        public IEnumerator<T> GetEnumerator()
        {
            for (StackItem item = first; item != null; item = item.next)
                yield return item.data;
        }
    }
}
