﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _10_Ubg_HashDict_Di
{
    // Erstellen Sie eine Klasse HashDict, welches ebenfalls Schlüssel-/Wertpaare abspeichern kann.
    // Allerdings sollen die Schlüssel-/Wertpaare nicht in einer Liste, sondern in einem
    // hinreichend großen Feld abgelegt werden.
    // Der Schlüssel soll direkt in einen Feldplatz umgerechnet werden (Hashfunktion), etwaige
    // Konflikte sind geeignet zu behandeln.
    // Für die Generierung eines Hashcodes gibt es bereits in Object eine Methode:
    //    int GetHashCode()
    // Erstellen Sie
    // - indexer-Zugriff (get;set)
    // - GetEnumerator()
    // - Contains-Methode
    class HashDict<K,V> where K:class,IComparable<K>
    {
        K[] keys;
        V[] values;
        int length;

        public HashDict(int length=100)
        {
            this.length = length;
            keys = new K[length];
            values = new V[length];
        }

        private int SearchInd(K key)
        {
            int ind = Math.Abs(key.GetHashCode()) % length;
            while (keys[ind] != null && keys[ind].CompareTo(key) != 0)
                ind = (ind + 1) % length;
            return ind;
        }

        public V this[K key]
        {
            get
            {
                int ind = SearchInd(key);
                if (keys[ind] == null)
                    throw new Exception($"Der Schlüssel {key} wurde nicht gefunden");
                return values[ind];
            }
            set
            {
                int ind = SearchInd(key);
                keys[ind] = key;
                values[ind] = value;
            }
        }

        public IEnumerator<KeyValuePaar<K,V>> GetEnumerator()
        {
            for (int i = 0; i < length; i++)
                if (keys[i] != null)
                    yield return new KeyValuePaar<K,V>(keys[i], values[i]);
        }
        public override string ToString()
        {
            string res = "";
            for (int i = 0; i < length; i++)
                if (keys[i] != null)
                    res += keys[i].ToString() + values[i].ToString() + "\n";
            return res;
        }
    }
}
