﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;

namespace _11_5_BinTreePersVerwaltung
{
    class BinTree<T> : IEnumerable
        where T:IComparable<T>
    {
        class Node
        {
            public T data;
            public Node left = null, right = null;
            public Node(T Data) { data = Data; }

            public IEnumerable<T> enumerate()
            {
                if (left != null)
                    foreach (T item in left.enumerate())
                        yield return item;
                yield return data;
                if (right != null)
                    foreach (T item in right.enumerate())
                        yield return item;
            }
            public void print()   // Methode der Klasse Node
            {
                if (left != null)
                    left.print();
                Console.WriteLine(this.data);
                if (right != null)
                    right.print();
            }
        }
        private Node root = null;

        public void Insert(T Data)
        {
            Node newItem = new Node(Data);
            if (root == null)           // Gibt es schon einen Baum?
                root = newItem;         // Nein: Neues Element ist Wurzel des Baums
            else
            {
                Node tmp = root;
                bool found = false;
                do      // Solange die Einfügeposition noch nicht gefunden ist, tue ...
                {
                    if (newItem.data.CompareTo(tmp.data) < 0)   // x < y => (x-y) < 0
                    {   // links oder rechts von dem aktuellen Element einfügen?
                        // LINKS
                        if (tmp.left == null)
                        {                   // Ist der linke Ast noch leer?
                            tmp.left = newItem;   // Dann hier einfügen
                            found = true;
                        }
                        else
                            tmp = tmp.left; // Sonst dem linken Ast folgen
                    }
                    else
                    {       // RECHTS
                        if (tmp.right == null)
                        {                   // Ist der rechte Ast noch leer?
                            tmp.right = newItem;  // Dann hier einfügen
                            found = true;
                        }
                        else                // Sonst dem rechten Ast folgen
                            tmp = tmp.right;
                    }
                } while (!found);
            }
        }

        public IEnumerator GetEnumerator()
        {
            foreach (T item in root.enumerate())
                yield return item;
        }
        public void Print()
        {
            if (root != null)
                root.print();
        }
    }
}
