﻿using System;

namespace _12_UbgTransformingServer
{
    class Client
    {
        public string Name { get; }
        public Client(string Name) { this.Name = Name; }

        // ToDo: statische "Listener" Methode
        public static void Ausgabe(string msg)
        {
            Console.WriteLine($"static: {msg}");
        }
        // ToDo: nicht-statische "Listener" Methode
        public void Listen(string msg)
        {
            Console.WriteLine($"nicht-static: {Name}: {msg}");
        }
    }
    class Program
    {
        static void OldNewCorp(ref string msg)
        {
            msg = msg.Replace("ZZZ", "AAA");
        }
        static void Signature(ref string msg)
        {
            msg += "\npowered by wonderland server";
        }
        // ToDo: Realisieren Sie die folgenden Transformationen:
        //    x  Signature ( ... ) fügt der Nachricht eine Signatur an
        //    x  OldNewCorp ( ... ) ersetzt ZZZ durch AAA
        //    x  Beautify ( ... ) ersetzt "liebe Kunden" durch "verehrte Kunden"
        static void Main(string[] args)
        {
            MsgServer server = new MsgServer();
            // ToDo: Fügen Sie einige Transformationen hinzu
            // msg --> OldNewCorp  --> Signature
            server.Transformations += OldNewCorp;
            server.Transformations += Signature;

            Client mueller = new Client("Müller");
            Client meier = new Client("Meier");
            Client huber = new Client("Huber");

            // ToDo: Registrieren Sie einige Listener 
            server.Notify += Client.Ausgabe;
            server.Notify += meier.Listen;

            server.SendMsg("Herzlich Willkommen, liebe Kunden! ZZZ Corporation");

            // ToDo: Registrieren Sie weitere Listener an und entfernen
            //       Sie einen Listener
            server.Notify -= meier.Listen;
            server.Notify += mueller.Listen;
            server.Notify += huber.Listen;
            Console.WriteLine("---------");
            // ToDo: Entfernen Sie die Signature Transformation
            server.Transformations -= Signature;

            server.SendMsg("Wir wünschen einen erfolgreichen Tag, liebe Kunden, ZZZ Corporation");
        }
    }
}
