﻿using System;

namespace _13_2_VererbungWdhlg
{
    class Program
    {
        static void Main(string[] args)
        {
            /*[1]*/
            IBetankbar[] fuhrpark = { new DieselFZ(), new BenzinFZ(), new ElektrischesFZ() };
            foreach (/*2*/IBetankbar fz in fuhrpark)
                macheFahrbereit(/*3:nix*/fz);
        }
        public static void macheFahrbereit(IBetankbar/*4*/ fz)
        {
            fz.tanke();  // für 4 auf tanke() schauen!
        }
    }

    interface IBetankbar /*[5]*/
    {
        void tanke();
    }
    interface IBefuellbar /*[6]*/ : IBetankbar
    {
        double Fuellstand { get; set; }
        void befuelle();
    }
    interface ILadbar /*[7]*/ : IBetankbar
    {
        double Ladestand { get; set; }
        void lade();
    }
    abstract class FossilerAntrieb : IBefuellbar
    {
        /*[8]*/
        protected double fuellstand;
        public double Fuellstand  /*[9]*/
        {
            get { return fuellstand; }
            set
            {
                if (value >= 0.0 && value <= 1.0)
                    fuellstand = value;
            }
        }
        /*[10]*/
        public abstract void befuelle();
        /*[11]*/
        public void tanke()
        {
            if (fuellstand < 0.5)
                befuelle();
            else
                Console.WriteLine("Noch fahrbereit");
        }
    }

    class DieselFZ : FossilerAntrieb
    {
        /*12*/
        public override void befuelle()
        {
            Console.WriteLine("Dieselhandschuhe anziehen, Zapfpistole entnehmen, tanken, Zapfpistole in Halterung.");
            fuellstand = 1.0;
        }
    }
    class BenzinFZ : FossilerAntrieb
    {
        /*13*/
        public override void befuelle()
        {
            Console.WriteLine("Zapfpistole entnehmen, tanken, Zapfpistole in Halterung.");
            fuellstand = 1.0;
        }
    }

    abstract class ElektrischerAntrieb : ILadbar
    {
        /*[14]*/
        protected double ladestand;
        public double Ladestand/*[15]*/
        {
            get { return ladestand; }
            set
            {
                if (value >= 0.0 && value <= 1.0) ladestand = value;
            }
        }

        /*[16]*/
        public abstract void lade();
        /*[17]*/
        public void tanke()
        {
            if (ladestand < 0.5)
                lade();
            else
                Console.WriteLine("Noch fahrbereit");
        }
    }
    class ElektrischesFZ : ElektrischerAntrieb
    {
        /*[18]*/
        public override void lade()
        {
            Console.WriteLine("Ladestecker entnehmen, warten, Ladestecker in Halterung.");
            ladestand = 1.0;
        }
    }
}