﻿using System;
using System.Collections.Generic;

namespace _13_Ubg_ApplyAll
{
    /* Schreiben Sie die folgenden generischen Methoden:
     * 
     * 1) ApplyAll, die für Felder eines beliebigen Typs, eine übergebene Funktion auf alle Feldelemente anwendet
     * und das derart modifizierte Feld zurückliefert.
     * 
     * 2) Select soll eine übergebene Filterfunktion auf alle Feldelemente anwenden und nur diejenigen zurückliefern,
     * bei denen das Feldelement die Filterkriterien erfüllt. Hierfür kann die generische MS Liste<> verwendet werden.
     * 
     * Schreiben Sie für unterschiedliche Basistypen Lambda-Ausdrücke oder anonyme Methoden
     */
    class Program
    {
        delegate T MeineFkt<T>(T x);
        //delegate int MeineFkt<int>(int x)
        delegate bool MeinFilter<T>(T x);
        //delegate bool Predicate<T>(T x);

        // static int[] ApplyAll<int>(MeineFkt<int> fkt, params int[] werte)
        // static string[] ApplyAll<string>(MeineFkt<string> fkt, params string[] werte)
        static T[] ApplyAll<T>(MeineFkt<T> fkt, params T[] werte)
        {
            T[] res = new T[werte.Length];
            for (int i = 0; i < werte.Length; i++)
            {
                res[i] = fkt(werte[i]);
                Console.Write($"{res[i]}  ");
            }
            Console.WriteLine();
            return res;
        }

        static T[] Select<T>(Predicate<T> filter, params T[] werte)
        {
            List<T> res = new List<T>();
            foreach (var item in werte)
            {
                if (filter(item))
                {
                    res.Add(item);
                    Console.Write($"{item}  ");
                }
            }
            Console.WriteLine();
            return res.ToArray();
        }


        static void Main(string[] args)
        {
            ApplyAll(x => x + 1, 10, 30, 40, 50, 60, 70, 80, 100);

            ApplyAll(x => (int)(x * 0.5), 10, 30, 40, 50, 60, 70, 80, 100);
            ApplyAll(delegate (int x) { return (int)(x * 0.5); }, 10, 30, 40, 50, 60, 70, 80, 100);
            
            ApplyAll(delegate (int x) { return x + 1; }, ApplyAll(x => 2 * x, 10, 20, 30));
            ApplyAll(x => x + 1, "Anton", "Berta", "Claudia");
            ApplyAll(x => x.ToUpper(), "Anton", "Berta", "Claudia");

            Select(x => x > 50, 10, 30, 40, 50, 60, 70, 80, 100);
            Select(x => x.Contains("er"), "Anton", "Berta", "Claudia", "Dieter");
            Select(x => true, "Anton", "Berta", "Claudia", "Dieter");

            ApplyAll(x => x.ToUpper(), Select(x => x.Contains("er"), "Anton", "Berta", "Claudia", "Dieter"));
        }
    }
}
