﻿using System;
using System.Collections.Generic;

namespace _13_UbgCycleList_Mo
{
    class CycleList
    {
        class LItem
        {
            public string name;
            public LItem next;
            public LItem(string Name) { name = Name; next = null; }
        }
        LItem first = null, last = null;
        LItem nextIn, nextOut;
        int capacity;
        public int Count { get; private set; } // Anzahl gerade im Puffer gespeicherter Elemente
        public void AddEnd(string Name) // wie bisher
        {
            LItem newItem = new LItem(Name);
            if (first == null)
                first = last = newItem;
            else
            {
                last.next = newItem;
                last = newItem;
            }
        }
        public CycleList()
        {
            for (int i = 0; i < 10; i++)
                AddEnd(null);
            last.next = first;
            Count = 0;
            capacity = 10;
            nextIn = nextOut = first;
        }
        public void Write(string Name)
        {
            if (Count == capacity)
                throw new Exception("Buffer Full");
            nextIn.name = Name;
            nextIn = nextIn.next;
            Count++;
        }
        public string Read()
        {
            if (Count == 0)
                throw new Exception("Buffer Empty");

            string tmp = nextOut.name;
            nextOut.name = null;
            nextOut = nextOut.next;
            Count--;
            return tmp;
        }
        public void Enlarge(int n)
        {
            // 1) "Z" suchen
            LItem item = first;
            while (item.next != nextIn)
                item = item.next;
            // JETZT: item zeigt auf "Z", nextIn ist der Nachfolger

            for (int i = 0; i < n; i++)
            {
                LItem newItem = new LItem(null);
                newItem.next = item.next;
                item.next = newItem;
                capacity++;
            }
            nextIn = item.next;
        }
        public IEnumerator<string> GetEnumerator()
        {
            LItem item = nextOut;
            for (int i = 0; i < Count; i++)
            {
                yield return item.name;
                item = item.next;
            }
        }

    }
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Hello World!");
        }
    }
}
